import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import java.awt.GridLayout;
import java.awt.Container;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.BorderLayout;
import java.awt.Image;
import java.awt.Toolkit;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

import java.util.HashMap;

import java.lang.Math;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JFrame;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.BorderFactory;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JRadioButton;
import javax.swing.ButtonGroup;
import javax.swing.JProgressBar;
import javax.swing.SwingWorker;


public class Fenetre extends JFrame
{
	private Case[] tabCases;
	private int casesLibres;
	private IA ia;
	private Manager man;
	
	private JMenuBar menuBar = new JMenuBar();
	private JMenu fichier = new JMenu("Fichier");
		
	private JMenuItem item1 = new JMenuItem("Nouvelle Partie");
	private JMenuItem item2 = new JMenuItem("Nouvelle partie avec auto-apprentissage");
	private JMenuItem item3 = new JMenuItem("Statistiques");
	private JMenuItem item5 = new JMenuItem("Paramtres d'apprentissage");
	private JMenuItem item6 = new JMenuItem("Fermer");
	
	
	
	public Fenetre()
	{	
		super();
		
		this.setTitle("Tic Tac Toe");
		this.setSize(400, 500);
		this.setLocationRelativeTo(null);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
		//intialisation du menu
		NouvellePartieListener nouvPart = new NouvellePartieListener();
		nouvPart.setFenetre(this);
		item1.addActionListener(nouvPart);
		this.fichier.add(item1);
		
		ReinitialisationListener reinit = new ReinitialisationListener();
		reinit.setFenetre(this);
		item2.addActionListener(reinit);
		this.fichier.add(item2);
		
		StatistiquesListener stat = new StatistiquesListener();
		item3.addActionListener(stat);
		this.fichier.add(item3);
		
		ParametreAppListener paramApp = new ParametreAppListener();
		paramApp.setFenetre(this);
		item5.addActionListener(paramApp);
		this.fichier.add(item5);
		
		item6.addActionListener(new ActionListener()
			{
				public void actionPerformed(ActionEvent arg0) 
				{
					System.exit(0);
				}				
			});
		this.fichier.add(item6);
		this.menuBar.add(fichier);
		this.setJMenuBar(menuBar);
		
		Image icone = Toolkit.getDefaultToolkit().getImage("./ImageTicTacToe.png");
		this.setIconImage(icone);

		
		//initialisation de la partie		
		this.premierePartie(false,1.0,-1.0,0.5,0.0,1,3,true);
	}
	
	public void premierePartie(boolean autoapp, double recVict, double recDef,double gamma, double probaJeuxHasard, double tau, int fonctionUtilisee,boolean initialisation)
	{
		tabCases = new Case[9];
		ia  = new IA(this, recVict, recDef, gamma, probaJeuxHasard, tau, fonctionUtilisee,initialisation);
		man = new Manager();
		this.setContentPane(new Container());
		this.setLayout(new GridLayout(3, 3));
		this.setVisible(true);
		this.afficherDialogueJeux();
		ExecuteAutoApprentissage ea= new ExecuteAutoApprentissage(this, this.ia,autoapp);
		ea.execute();
	}
	
	public void nouvellePartie()
	{
		this.setContentPane(new Container());
		this.setLayout(new GridLayout(3, 3));
		for(int i=0; i<9 ;i++)
		{
			tabCases[i] = new Case();
			JeuxListener jeuxList = new JeuxListener();
			jeuxList.setFenetre(this);
			tabCases[i].addActionListener(jeuxList);
			this.getContentPane().add(tabCases[i]);
		}
		this.casesLibres=9;
		ia.setNouvellePartie();
		if(ia.getSigneIa()==1)
		{
			ia.jouer(tabCases);
			this.rafraichirPlateauJeux();
			this.setVisible(true);
		}
		this.setVisible(true);
	}
	
	public void autoApprendre(IA ia, int nbrPartiesAJouer,IA ia2)//cette fonction fait en ralit dsaprendre...
	{
		if(ia.getSigneIa()==1)
		{
			ia2.setSigneIa(2);
		}
		else
		{
			ia2.setSigneIa(1);
		}
		int nbrParties=0;
		this.casesLibres=9;
		for(int i=0;i<9;i++)
		{
			tabCases[i]=new Case();
		}
		
		while(nbrParties<nbrPartiesAJouer)
		{
			if(!man.partieGagnee(tabCases))
			{
				if(ia.getSigneIa()==1)
				{
					ia.jouer(tabCases);
				}
				else
				{
					ia2.jouer(tabCases);
				}
				if(!man.partieGagnee(tabCases))
				{
					if(casesLibres!=0)
					{
						if(ia.getSigneIa()==1)
						{
							ia2.jouer(tabCases);
						}
						else
						{
							ia.jouer(tabCases);
						}
					}
					else
					{
						ia.ajouterPartie(2);
						ia2.ajouterPartie(2);
						nbrParties++;
						afficherTabCaseConsole(tabCases);
						ia.setNouvellePartie();
						ia2.setNouvellePartie();
						this.rafraichirPlateauJeux();
						for(int i=0;i<9;i++)
						{
							tabCases[i]=new Case();
						}
						casesLibres=9;
						System.out.println("Nombre de parties joues : " + nbrParties);
					}
				}
				else
				{
					if(ia.getSigneIa()==1)
					{
						ia.mettreAJourMemoire(true);
						ia.ajouterPartie(1);
						ia2.mettreAJourMemoire(false);
						ia2.ajouterPartie(0);
					}
					else
					{
						ia.mettreAJourMemoire(false);
						ia.ajouterPartie(0);
						ia2.mettreAJourMemoire(true);
						ia2.ajouterPartie(1);
					}
					ia.setNouvellePartie();
					ia2.setNouvellePartie();
					nbrParties++;
					afficherTabCaseConsole(tabCases);
					this.rafraichirPlateauJeux();
					for(int i=0;i<9;i++)
					{
						tabCases[i]=new Case();
					}
					casesLibres=9;
					System.out.println("Nombre de parties joues : " + nbrParties);
				}
			}
			else
			{
				if(ia.getSigneIa()==1)
				{
					ia.mettreAJourMemoire(false);
					ia.ajouterPartie(0);
					ia2.mettreAJourMemoire(true);
					ia2.ajouterPartie(1);
				}
				else
				{
					ia.mettreAJourMemoire(true);
					ia.ajouterPartie(1);
					ia2.mettreAJourMemoire(false);
					ia2.ajouterPartie(0);
				}
				ia.setNouvellePartie();
				ia2.setNouvellePartie();
				nbrParties++;
				afficherTabCaseConsole(tabCases);
				this.rafraichirPlateauJeux();
				for(int i=0;i<9;i++)
				{
					tabCases[i]=new Case();
				}
				casesLibres=9;
				System.out.println("Nombre de parties joues : " + nbrParties);
			}
		}
		this.afficherGraphiques(ia,ia2);
	}
	
	public void diminuerCasesLibres()
	{
		this.casesLibres=casesLibres-1;
	}

	public int getCasesLibres()
	{
		return casesLibres;
	}
	
	public IA getIA()
	{
		return ia;
	}

	public void rafraichirPlateauJeux()
	{
		this.setContentPane(new Container());
		this.setLayout(new GridLayout(3, 3));
		for(int i=0; i<9 ;i++)
		{
			this.getContentPane().add(tabCases[i]);
		}
		//this.setVisible(true);
	}
	
	public void afficherDialogueVictoire()
	{
		int option = JOptionPane.showConfirmDialog(null, "Vous avez gagn! Dsirez-vous faire une nouvelle partie?", "Victoire!", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
		if(option == JOptionPane.OK_OPTION)
		{
			this.nouvellePartie();
		}
		else
		{
			int truc = JOptionPane.showConfirmDialog(null, "Etes-vous vraiment sur de vouloir quitter? La mmoire sera perdue...", "Vraiment??????", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
			if(truc == JOptionPane.OK_OPTION)
			{
				System.exit(0);
			}
			else
			{
				this.nouvellePartie();
			}
		}
	}
	
	public void afficherDialogueDefaite()
	{
		int option = JOptionPane.showConfirmDialog(null, "Vous avez perdu... Dsirez-vous faire une nouvelle partie?", "Dfaite...", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
		if(option == JOptionPane.OK_OPTION)
		{
			this.nouvellePartie();
		}
		else
		{
			int truc = JOptionPane.showConfirmDialog(null, "Etes-vous vraiment sur de vouloir quitter? La mmoire sera perdue...", "Vraiment??????", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
			if(truc == JOptionPane.OK_OPTION)
			{
				System.exit(0);
			}
			else
			{
				this.nouvellePartie();
			}
		}
	}
	
	public void afficherDialogueNul()
	{
		int option = JOptionPane.showConfirmDialog(null, "Partie nulle! Dsirez-vous faire une nouvelle partie?", "Partie nulle", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
		if(option == JOptionPane.OK_OPTION)
		{
			this.nouvellePartie();
		}
		else
		{
			int truc = JOptionPane.showConfirmDialog(null, "Etes-vous vraiment sur de vouloir quitter? La mmoire sera perdue...", "Vraiment??????", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
			if(truc == JOptionPane.OK_OPTION)
			{
				System.exit(0);
			}
			else
			{
				this.nouvellePartie();
			}
		}
	}
	
	public void afficherDialogueJeux()
	{
		String[] tour = {"Jouer en premier", "Jouer en deuxieme", "Quitter"};
		int rang = JOptionPane.showOptionDialog(null, 
										"Voulez-vous :",
										"",
										JOptionPane.YES_NO_CANCEL_OPTION,
										JOptionPane.QUESTION_MESSAGE,
										null,
										tour,
										null);
		if(rang == 0)
		{
			ia.setSigneIa(2);
		}
		else if(rang ==1)
		{
			ia.setSigneIa(1);
		}
		else if(rang ==2)
		{
			System.exit(0);
		}
	}
	
	public void afficherDialogueReglageParametresApp(String title, IA ia)
	{
		DialogueReglageParametresApp dial = new DialogueReglageParametresApp(this, title, true, ia);
		dial.showDial();
	}
	
	public void afficherTabCaseConsole(Case[] tabCases)
	{
		System.out.println(tabCases[0].getType()+" "+tabCases[1].getType()+" "+tabCases[2].getType());
		System.out.println(tabCases[3].getType()+" "+tabCases[4].getType()+" "+tabCases[5].getType());
		System.out.println(tabCases[6].getType()+" "+tabCases[7].getType()+" "+tabCases[8].getType());
	}
	
	public void afficherGraphiques(IA ia1, IA ia2)
	{
		new FenetreGraphiques(ia1, ia2);
	}
	
	//Classes d'coutes : 
	public class JeuxListener implements ActionListener
	{
		Fenetre fen;
		
		public void setFenetre(Fenetre fen)
		{
			this.fen = fen;
		}
		
		public void actionPerformed(ActionEvent event)
		{
			fen.diminuerCasesLibres();
			for(int i=0; i<9 ;i++)
			{
				if(event.getSource()==tabCases[i])
				{	
					if(ia.getSigneIa()==2)//si on joue les ronds
					{
						tabCases[i] = new CaseRond();
						tabCases[i].setEnabled(false);
					}
					else
					{
						tabCases[i] = new CaseCroix();
						tabCases[i].setEnabled(false);
					}
				}
			}
			fen.rafraichirPlateauJeux();
			fen.setVisible(true);
			if(man.partieGagnee(tabCases)) //si la partie est gagne par le joueur
			{
				man.setFinPartie(tabCases);
				man.augmenterNbrPartieGagnees(1);
				ia.mettreAJourMemoire(false);
				fen.setVisible(true);
				fen.afficherDialogueVictoire();
			}
			else
			{
				ia.jouer(tabCases);
				fen.rafraichirPlateauJeux();
				if(man.partieGagnee(tabCases)) //si la partie est gagne par l'ia
				{
					man.setFinPartie(tabCases);
					man.augmenterNbrPartiePerdues(1);
					ia.mettreAJourMemoire(true);
					fen.setVisible(true);
					fen.afficherDialogueDefaite();
				}
				if(fen.casesLibres==0)//si la partie est nulle
				{
					man.augmenterNbrPartieNulles(1);
					man.setFinPartie(tabCases);	
					fen.setVisible(true);
					fen.afficherDialogueNul();
				}
			}
			fen.setVisible(true);
		}
	}

	public class NouvellePartieListener implements ActionListener
	{
		Fenetre fen;
		
		public void setFenetre(Fenetre fen)
		{
			this.fen = fen;
		}
		
		public void actionPerformed(ActionEvent event)
		{
			fen.nouvellePartie();
		}
	}
	
	public class ReinitialisationListener implements ActionListener
	{
		Fenetre fen;
		
		public void setFenetre(Fenetre fen)
		{
			this.fen = fen;
		}
		
		public void actionPerformed(ActionEvent event)
		{
			fen.premierePartie(true,fen.getIA().getRecPartieGagnee(),fen.getIA().getRecPartiePerdue(),fen.getIA().getGamma(),fen.getIA().getProbaHasard(),fen.getIA().getTau(),fen.getIA().getFonctionUtilisee(), fen.getIA().getInitialisation());
		}
	}
	
	public class StatistiquesListener implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			double nbrPartiesJouees = man.getPartiesPerdues()+man.getPartiesGagnees()+man.getPartiesNulles();
			double pourCentVict = Math.floor((man.getPartiesGagnees()/nbrPartiesJouees)*10000)/100;
			double pourCentDef = Math.floor((man.getPartiesPerdues()/nbrPartiesJouees)*10000)/100;		
			double pourCentNul = Math.floor((man.getPartiesNulles()/nbrPartiesJouees)*10000)/100;
			int nbrParties = (int)nbrPartiesJouees;
			System.out.println(pourCentVict + " "+pourCentDef+" " + pourCentNul);
			String chaine1 = "Statistiques : \n";
			String chaine2 = "Nombre de parties joues : " + nbrParties + "\n";
			String chaine3 = "Nombre de parties gagnes : " +man.getPartiesGagnees() + 
										" ("+pourCentVict+"%)\n";
			String chaine4 =  "Nombre de parties perdues : " +man.getPartiesPerdues() + 
										" ("+pourCentDef+"%)\n";
			String chaine5 =  "Nombre de parties nulles : " +man.getPartiesNulles() + 
										" ("+pourCentNul+"%)\n";
			String chaine = chaine1 +  chaine2 +  chaine3 +  chaine4 +  chaine5;
			JOptionPane.showMessageDialog(null, chaine, "Informations personnage", JOptionPane.INFORMATION_MESSAGE);
		
		}
	}

	public class ParametreAppListener implements ActionListener
	{
		Fenetre fen;
		
		public void setFenetre(Fenetre fen)
		{
			this.fen = fen;
		}
		
		public void actionPerformed(ActionEvent event)
		{
			fen.afficherDialogueReglageParametresApp("Paramtres d'apprentissage de l'ia", fen.getIA());
			ia.setMemoire(new HashMap<int[][], Double[]>());
			JOptionPane.showMessageDialog(null, "La mmoire a t rinitialise", "Information", JOptionPane.INFORMATION_MESSAGE);
			fen.nouvellePartie();
		}
	}
	
	public class DialogueReglageParametresApp extends JDialog
	{
		private JTextField recVict, recDef, gamma, probaJeuxHasard, tau;
		private JRadioButton niveau1, niveau2, niveau3, niveau4, niveau5, identique, optimise;
		private int fonctionSelctionnee = 0;
		boolean initialisation;

		private Fenetre fen;
		private IA ia;
		
		public DialogueReglageParametresApp(Fenetre parent, String titre, boolean modal, IA ia)
		{
			super(parent, titre, modal);
			this.fen = parent;
			this.ia=ia;
			this.setSize(550, 460);
			this.setLocationRelativeTo(null);
			this.setResizable(false);
			this.setDefaultCloseOperation(JDialog.DO_NOTHING_ON_CLOSE);
			this.initDialogue();
		}

		public void showDial()
		{
			this.setVisible(true);
		}
		
		public void initDialogue()
		{
			
			JPanel panRecVict = new JPanel();
			panRecVict.setBackground(Color.white);
			panRecVict.setPreferredSize(new Dimension(220, 60));
			panRecVict.setBorder(BorderFactory.createTitledBorder("Rcompense lors d'une victoire :"));
			String recVictActuelle = ((Double)ia.getRecPartieGagnee()).toString();
			recVict = new JTextField(recVictActuelle);
			recVict.setPreferredSize(new Dimension(90, 25));
			panRecVict.add(recVict);
			
			JPanel panRecDef = new JPanel();
			panRecDef.setBackground(Color.white);
			panRecDef.setPreferredSize(new Dimension(220, 60));
			panRecDef.setBorder(BorderFactory.createTitledBorder("Rcompense lors d'une dfaite :"));
			String recDefActuelle = ((Double)ia.getRecPartiePerdue()).toString();
			recDef = new JTextField(recDefActuelle);
			recDef.setPreferredSize(new Dimension(90, 25));
			panRecDef.add(recDef);
			
			JPanel panGamma = new JPanel();
			panGamma.setBackground(Color.white);
			panGamma.setPreferredSize(new Dimension(220, 60));
			panGamma.setBorder(BorderFactory.createTitledBorder("Rglage du coefficient gamma :"));
			String gammaActuel = ((Double)ia.getGamma()).toString();
			gamma = new JTextField(gammaActuel);
			gamma.setPreferredSize(new Dimension(90, 25));
			panGamma.add(gamma);
			
			JPanel panProba = new JPanel();
			panProba.setBackground(Color.white);
			panProba.setPreferredSize(new Dimension(220, 60));
			panProba.setBorder(BorderFactory.createTitledBorder("Probabilit d'exploration (p-glouton) :"));
			String probaActuelle = ((Double)ia.getProbaHasard()).toString();
			probaJeuxHasard = new JTextField(probaActuelle);
			probaJeuxHasard.setPreferredSize(new Dimension(90, 25));
			panProba.add(probaJeuxHasard);
			
			JPanel panTau = new JPanel();
			panTau.setBackground(Color.white);
			panTau.setPreferredSize(new Dimension(220, 60));
			panTau.setBorder(BorderFactory.createTitledBorder("Tau (pour Boltzman)"));
			String tauActuel = ((Double)ia.getTau()).toString();
			tau = new JTextField(tauActuel);
			tau.setPreferredSize(new Dimension(90, 25));
			panTau.add(tau);
			
			JPanel panNiveau = new JPanel();
			panNiveau.setBackground(Color.white);
			panNiveau.setBorder(BorderFactory.createTitledBorder("Algorithme de choix de jeux"));
			panNiveau.setPreferredSize(new Dimension(440, 120));
			niveau1 = new JRadioButton("Choix au hasard");
			niveau2 = new JRadioButton("Choix sans apprentissage");
			niveau3 = new JRadioButton("Choix SARSA p-glouton");
			niveau4 = new JRadioButton("Choix SARSA SoftMax");
			niveau5 = new JRadioButton("Choix SARSA Boltzmann");
			fonctionSelctionnee = ia.getFonctionUtilisee();
			switch(fonctionSelctionnee)
			{
				case 1 : niveau1.setSelected(true);
					break;
				case 2 : niveau2.setSelected(true);
					break;
				case 3 : niveau3.setSelected(true);
					break;
				case 4 : niveau4.setSelected(true);
					break;
				case 5 : niveau5.setSelected(true);
					break;	
				default : niveau1.setSelected(true);
			}
			ButtonGroup bg = new ButtonGroup();
			bg.add(niveau1);
			bg.add(niveau2);
			bg.add(niveau3);
			bg.add(niveau4);
			bg.add(niveau5);
			panNiveau.add(niveau1);
			panNiveau.add(niveau2);
			panNiveau.add(niveau3);
			panNiveau.add(niveau4);
			panNiveau.add(niveau5);
			
			JPanel panInitialisation = new JPanel();
			panInitialisation.setBackground(Color.white);
			panInitialisation.setBorder(BorderFactory.createTitledBorder("Initialisation : "));
			panInitialisation.setPreferredSize(new Dimension(440, 70));
			identique = new JRadioButton("Identique pour tous");
			optimise = new JRadioButton("Optimise");
			initialisation = ia.getInitialisation();
			if(initialisation)
			{
				optimise.setSelected(true);
			}
			else
			{
				identique.setSelected(true);
			}
			ButtonGroup bg2 = new ButtonGroup();
			bg2.add(identique);
			bg2.add(optimise);
			panInitialisation.add(identique);
			panInitialisation.add(optimise);
			
			JPanel content = new JPanel();
			content.setBackground(Color.white);
			content.add(panRecVict);
			content.add(panRecDef);
			content.add(panGamma);
			content.add(panProba);
			content.add(panTau);
			content.add(panNiveau);
			content.add(panInitialisation);
			
			JPanel control = new JPanel();
			JButton okBouton = new JButton("OK");
			okBouton.addActionListener(new ActionListener(){
				
				public void actionPerformed(ActionEvent arg0) 
				{	
					ia.setRecPartieGagnee(Double.valueOf(recVict.getText()));
					ia.setRecPartiePerdue(Double.valueOf(recDef.getText()));
					ia.setGamma(Double.valueOf(gamma.getText()));
					ia.setProbaHasard(Double.valueOf(probaJeuxHasard.getText()));
					ia.setTau(Double.valueOf(tau.getText()));
					ia.setFonctionUtilisee(this.fonctionSelectionnee());
					ia.setInitialisation(initialisation());
					setVisible(false);
				}
				
				public int fonctionSelectionnee()
				{
					if(niveau1.isSelected())
					{
						return 1;
					}
					else if(niveau2.isSelected())
					{
						return 2;
					}
					else if(niveau3.isSelected())
					{
						return 3;
					}
					else if(niveau4.isSelected())
					{
						return 4;
					}
					else if(niveau5.isSelected())
					{
						return 5;
					}
					else
					{
						return 0;
					}
				}
				
				public boolean initialisation()
				{
					if(optimise.isSelected())
					{
						return true;
					}
					else
					{
						return false;
					}
				}
			});
			
			JButton cancelBouton = new JButton("Annuler");
			cancelBouton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					setVisible(false);
				}			
			});
			
			control.add(okBouton);
			control.add(cancelBouton);
			
			this.getContentPane().add(content, BorderLayout.CENTER);
			this.getContentPane().add(control, BorderLayout.SOUTH);
		}
	}
	
	 public class ExecuteAutoApprentissage extends SwingWorker<Integer, Object> 
	 {
		 private Fenetre fen;
		 private IA ia1;
		 private IA ia2;
		 private int nbrPartiesAJouer=0;
		 private JFrame fenetre;
		 private JProgressBar bar;
		 private boolean autoapp;
		 
		 public ExecuteAutoApprentissage(Fenetre fen, IA ia1,boolean autoapp)
		 {
			ia2  = new IA(fen, 1.0,-1.0,0.5,0.0,1,1,true);
			if(autoapp)
			{
				String nom = JOptionPane.showInputDialog(null, "Combien de partie l'ordinateur doit il effectuer?", "", JOptionPane.QUESTION_MESSAGE);
				if(nom==null)
				{
					nbrPartiesAJouer=0;
				}
				else
				{
					nbrPartiesAJouer=Integer.valueOf(nom);
					fen.afficherDialogueReglageParametresApp("Parametre d'apprentissage de l'ia adverse", ia2);
				}
			}
			fenetre = new JFrame();
			fenetre.setTitle("Apprentissage en cours...");
			fenetre.setSize(300, 80);
			fenetre.setLocationRelativeTo(null);
			fenetre.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
			fenetre.setAlwaysOnTop(true);
			Image icone = Toolkit.getDefaultToolkit().getImage("./ImageTicTacToe.png");
			fenetre.setIconImage(icone);
			bar=new JProgressBar();
			bar.setMaximum(100);
			bar.setMinimum(0);
			bar.setValue(0);
			bar.setStringPainted(true);
			fenetre.setContentPane(new Container());
			fenetre.setLayout(new BorderLayout());
			fenetre.getContentPane().add(bar, BorderLayout.CENTER);
			fenetre.setVisible(true);			 
			this.fen=fen;
			this.ia1=ia1;
			this.autoapp=autoapp;
			addPropertyChangeListener(new PropertyChangeListener() 
				{
	                public void propertyChange(PropertyChangeEvent evt) 
	                	{
	                    if("progress".equals(evt.getPropertyName())) 
	                    {
	                        bar.setValue((Integer) evt.getNewValue());
	                    }
	                }
	            });
		 }
		 
	     public Integer doInBackground() 
	     {
	    	 if(autoapp&&nbrPartiesAJouer>0)
	 		{
	    		autoApprendre();
	    		fen.afficherGraphiques(this.ia1,this.ia2);
	 		}
	    	return 0;
	     }
	     
	     public void autoApprendre()
	     {
	    	 
	    	 if(ia1.getSigneIa()==1)
		    	{
		    		ia2.setSigneIa(2);
		    	}
		    	else
		    	{
		    		ia2.setSigneIa(1);
		    	}
		    	int nbrParties=0;
		    	fen.casesLibres=9;
		    	for(int i=0;i<9;i++)
		    	{
		    		tabCases[i]=new Case();
		    	}
		    			
		    	while(nbrParties<nbrPartiesAJouer)
		    	{
		    		this.setProgress(100*(nbrParties)/nbrPartiesAJouer);
		    		if(!man.partieGagnee(tabCases))
		    		{
		    			if(ia1.getSigneIa()==1)
		    			{
		    				ia1.jouer(tabCases);
		    			}
		    			else
		    			{
		    				ia2.jouer(tabCases);
		    			}
		    			if(!man.partieGagnee(tabCases))
		    			{
		    				if(casesLibres!=0)
		    				{
		    					if(ia1.getSigneIa()==1)
		    					{
		    						ia2.jouer(tabCases);
		    					}
		    					else
		    					{
		    						ia1.jouer(tabCases);
		    					}
		    				}
		    				else
		    				{
		    					ia1.ajouterPartie(2);
		    					ia2.ajouterPartie(2);
		    					nbrParties++;
		    					//afficherTabCaseConsole(tabCases);
		    					ia1.setNouvellePartie();
		    					ia2.setNouvellePartie();
		    					fen.rafraichirPlateauJeux();
		    					for(int i=0;i<9;i++)
		    					{
		    						tabCases[i]=new Case();
		    					}
		    					casesLibres=9;
		    					//System.out.println("Nombre de parties joues : " + nbrParties);
		    				}
		    			}
		    			else
		    			{
		    				if(ia1.getSigneIa()==1)
		    				{
		    					ia1.mettreAJourMemoire(true);
		    					ia1.ajouterPartie(1);
		    					ia2.mettreAJourMemoire(false);
		    					ia2.ajouterPartie(0);
		    				}
		    				else
		    				{
		    					ia1.mettreAJourMemoire(false);
		    					ia1.ajouterPartie(0);
		    					ia2.mettreAJourMemoire(true);
		    					ia2.ajouterPartie(1);
		    				}
		    				ia1.setNouvellePartie();
		    				ia2.setNouvellePartie();
		    				nbrParties++;
		    				//afficherTabCaseConsole(tabCases);
		    				fen.rafraichirPlateauJeux();
		    				for(int i=0;i<9;i++)
		    				{
		    					tabCases[i]=new Case();
		    				}
		    				casesLibres=9;
		    				//System.out.println("Nombre de parties joues : " + nbrParties);
		    			}
		    		}
		    		else
		    		{
		    			if(ia1.getSigneIa()==1)
		    			{
		    				ia1.mettreAJourMemoire(false);
		    				ia1.ajouterPartie(0);
		    				ia2.mettreAJourMemoire(true);
		    				ia2.ajouterPartie(1);
		    			}
		    			else
		    			{
		    				ia1.mettreAJourMemoire(true);
		    				ia1.ajouterPartie(1);
		    				ia2.mettreAJourMemoire(false);
		    				ia2.ajouterPartie(0);
		    			}
		    			ia1.setNouvellePartie();
		    			ia2.setNouvellePartie();
		    			nbrParties++;
		    			//afficherTabCaseConsole(tabCases);
		    			fen.rafraichirPlateauJeux();
		    			for(int i=0;i<9;i++)
		    			{
		    				tabCases[i]=new Case();
		    			}
		    			casesLibres=9;
		    			//System.out.println("Nombre de parties joues : " + nbrParties);
		    		}
		    		this.setProgress(100);
		    	}
	     }

	     protected void done() 
	     {
	            try 
	            {
	                setProgress(100);
	                fenetre.setVisible(false);
	            	fen.nouvellePartie();
	            } 
	            catch(Exception e) 
	            {
	                e.printStackTrace();
	            }
	        }

	     
	 }
}
