import javax.swing.BorderFactory;
import javax.swing.JPanel;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.util.HashMap;

public class Graphique extends JPanel
{
	private IA ia1;
	private int partie;
	
	public Graphique(IA ia1, int partie)
	{
		super();
		this.ia1=ia1;
		this.partie=partie;
		this.setBackground(Color.white);
		if(Math.floor(5*ia1.getNbrPartiesJouees()/20)>200)
		{
			this.setPreferredSize(new Dimension((int)Math.floor(5*ia1.getNbrPartiesJouees()/20)+5, 160));
		}
		else
		{
			this.setPreferredSize(new Dimension(200, 160));
		}
		if(partie==1)
		{
			this.setBorder(BorderFactory.createTitledBorder("Nombre de parties gagnes "));
		}
		else if(partie==0)
		{
			this.setBorder(BorderFactory.createTitledBorder("Nombre de parties perdues "));
		}
		else if(partie ==2)
		{
			this.setBorder(BorderFactory.createTitledBorder("Nombre de parties nulles "));
		}
	}
	
	public void paintComponent(Graphics g)
	{
		super.paintComponent(g);
		
		HashMap<Integer,Integer> tabPartiesGagnees= ia1.getTabParties();
		HashMap<Integer,int[]> VicDef= new HashMap<Integer,int[]>();
		int ensembleDeParties=0;
		while(tabPartiesGagnees.get(20*(ensembleDeParties+1))!=null)
		{
			int nbrVictoires=0;
			int nbrDefaites=0;
			int nbrNuls=0;
			for(int i=1;i<21;i++)
			{
				if(tabPartiesGagnees.get(i+20*ensembleDeParties)==1)
				{
					nbrVictoires++;
				}
				else if(tabPartiesGagnees.get(i+20*ensembleDeParties)==0)
				{
					nbrDefaites++;
				}
				else if(tabPartiesGagnees.get(i+20*ensembleDeParties)==2)
				{
					nbrNuls++;
				}	
			}
			int[] truc = new int[3];
			truc[0] = nbrVictoires;
			truc[1]= nbrDefaites;
			truc[2]=nbrNuls;
			VicDef.put(ensembleDeParties, truc);
			ensembleDeParties++;
		}
		for(int i=0; i<ensembleDeParties; i++)
		{
			if(partie==1)
			{
				g.setColor(Color.yellow);
				g.fillRect((i+1)*5, 150-100*VicDef.get(i)[0]/20, 5,100*VicDef.get(i)[0]/20);
			}
			else if (partie==0)
			{
				g.setColor(Color.red);
				g.fillRect((i+1)*5, 150-100*VicDef.get(i)[1]/20, 5,100*VicDef.get(i)[1]/20);
			}
			else if(partie==2)
			{
				g.setColor(Color.orange);
				g.fillRect((i+1)*5, 150-100*VicDef.get(i)[2]/20, 5,100*VicDef.get(i)[2]/20);
			}
		}
	}
}
