import java.util.Iterator;
import java.util.Random;
import java.util.HashMap;
import java.lang.Math;


public class IA 
{
	private double recPartieGagnee;
	private double recPartiePerdue;
	private double nbrPartiesJouees = 0;
	private Fenetre fen;
	private int signeIa=0;
	private HashMap<int[][], Double[]> memoire; //stocke les rcompenses moyennes recues  partir d'un tat donn
	private HashMap<Integer,int[][]> partie; //stocke les diffrentes tapes d'une partie
	private int nbrCoups=0;
	private int fonctionUtilisee=3;
	private double gamma;
	private double probaJeuxHasard;
	private double tau;
	private boolean initialisation;
	private HashMap<Integer,Integer> tabParties;

	//----------------------------------------------------------------------------------------
	//Constructeur :
	
	public IA(Fenetre fen,double recVict, double recDef,double gamma,double probaJeuxHasard, double tau, int fonctionUtilisee, boolean initialisation)
	{
		this.fen = fen;
		this.memoire = new HashMap<int[][], Double[]>();
		this.partie = new HashMap<Integer,int[][]>();
		this.recPartieGagnee =recVict;
		this.recPartiePerdue = recDef;
		this.gamma = gamma;
		this.probaJeuxHasard= probaJeuxHasard;
		this.tau=tau;
		this.fonctionUtilisee=fonctionUtilisee;
		this.initialisation=initialisation;
		this.tabParties=new HashMap<Integer,Integer>();
		this.nbrPartiesJouees=0;
	}
	
	//----------------------------------------------------------------------------------------
	
	//----------------------------------------------------------------------------------------
	//Fonctions d'intelligence artificielle :
	
	public int jouer(Case[] tabCases)
	{
		int i=0;
		switch(fonctionUtilisee)
		{
		case 1 : i = this.choisirCaseHasard(tabCases);
			break;
		case 2 : i = this.choisirCaseSansApprentissage(tabCases);
			break;
		case 3 : i = this.choisirCaseAvecApprentissage1(tabCases);
			break;
		case 4 : i = this.choisirCaseAvecApprentissage2(tabCases);
			break;
		case 5 : i = this.choisirCaseAvecApprentissage3(tabCases);
			break;
		default :{ i = this.choisirCaseAvecApprentissage1(tabCases);
					System.out.println("Probleme dans le choix de la fonction");}
		}
		
		if(i!=10)
		{
			fen.diminuerCasesLibres();
			this.ajouterEtapePartie(tabCases,i);
			if(signeIa==1)
			{
				
				tabCases[i] = new CaseRond();
				tabCases[i].setEnabled(false);
			}
			else
			{
				tabCases[i] = new CaseCroix();
				tabCases[i].setEnabled(false);
			}
		}		
		return i;
	}

	public int choisirCaseHasard(Case[] tabCases)
	{
		Random r = new Random();
		boolean[] caseParcourues = new boolean[9];
		boolean totalParc = false; //vrai si on a dja test toute les cases
		for(int i=0; i<9;i++)
		{
			caseParcourues[i]=false;
		}
		int caseChoisie = r.nextInt(9);
		caseParcourues[caseChoisie]=true;
		while(tabCases[caseChoisie].getType()!=0 && !totalParc)
		{				
			caseChoisie = r.nextInt(9);
			caseParcourues[caseChoisie]=true;
			totalParc = true; //necessaire pour la boucle qui suit
			for(int i=0;i<9;i++)
			{
				totalParc = totalParc && caseParcourues[i];
			}
			if(tabCases[caseChoisie].getType()==0) //au cas ou la derniere est la bonne!
			{
				totalParc = false;
			}
		}
		if(totalParc)	//si on a tout parcouru sans succes
		{
			caseChoisie = 10;
		} //si on explore on prend un entier au hasard entre 0 et 8
		else
		{
			int[][] etat = creerEtat(tabCases, caseChoisie);
			Double[] recMemoire=new Double[2];
			recMemoire[0]=1.0;
			if(initialisation)
			{
				recMemoire[1]=this.probaVictoireInitiale(tabCases, caseChoisie);
			}
			else
			{
				recMemoire[1]=0.5;
			}
			memoire.put(etat, recMemoire);//On ajoute l'tat en mmoire
		}
		return caseChoisie;
	}
	
	public int choisirCaseSansApprentissage(Case[] tabCases)	//Choisit une case de facon optimisee : cherche  aligner des croix et a empecher l'autre d'aligner trois ronds (cf fonction rcompense)
	{
		double rec = 0;
		int caseChoisie=10;		//valeur par dfaut si on ne peut pas choisir de case
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{
				double recPartielle = this.probaVictoireInitiale(tabCases,i)+0.01*hasard();
				if(recPartielle>=rec)
				{
					rec=recPartielle;
					caseChoisie=i;
				}
			}
		}
		if(caseChoisie!=10)
		{
			int[][] etat = creerEtat(tabCases, caseChoisie);
			Double[] recMemoire=new Double[2];
			recMemoire[0]=1.0;
			if(initialisation)
			{
				recMemoire[1]=this.probaVictoireInitiale(tabCases, caseChoisie);
			}
			else
			{
				recMemoire[1]=0.5;
			}
			memoire.put(etat, recMemoire);//On ajoute l'tat en mmoire
		}
		return caseChoisie;
	}

		//-----------------------------------------------------------------------------------
		//Algorithmes SARSA
	
	//Choix p-glouton, p dcroissant :
	public int choisirCaseAvecApprentissage1(Case[] tabCases) // ne pas oublier de changer MAJmemoire!!!!!!(Utiliser MAJmemoire dans la classe fenetre, sous classe JeuxListener)
	{
		double nbrPassagesGlobalMoyen=1;
		int casesLibres=0;
		double exploration = hasard();
		int caseChoisie=10;		//valeur par dfaut si on ne peut pas choisir de case
		for(int i=0; i<9; i++)//On compte le nbr de fois que l'on est pass par ce tableau.
		{
			if(tabCases[i].getType()==0)
			{	
				casesLibres++;
				int[][] etat = creerEtat(tabCases, i);
				if(dejaVisite(etat)!=null)
				{
					nbrPassagesGlobalMoyen=(casesLibres*nbrPassagesGlobalMoyen+ memoire.get(dejaVisite(etat))[0])/(casesLibres+1);
				}
			}
		}
		if(exploration>probaJeuxHasard/nbrPassagesGlobalMoyen) //On explore si exploration est <= ... sinon choix raisonnable
		{
			double rec = -10000;		//pour etre sur qu'elle soit minimale...		
			for(int i=0; i<9; i++)
			{
				if(tabCases[i].getType()==0)
				{
					int[][] etat = creerEtat(tabCases, i);
					double recPartielle = 0;
					if(dejaVisite(etat)!=null)
					{
						recPartielle = memoire.get(dejaVisite(etat))[1];
					}
					else
					{
						Double[] recMemoire=new Double[2];
						recMemoire[0]=1.0;
						if(initialisation)
						{
							recMemoire[1]=this.probaVictoireInitiale(tabCases, i);
						}
						else
						{
							recMemoire[1]=0.5;
						}
						memoire.put(etat, recMemoire);//On ajoute l'tat en mmoire
						recPartielle = recMemoire[1];
					}
					if(recPartielle>=rec)
					{
						rec = recPartielle;
						caseChoisie = i;
					}
				}
			}
		}
		else	//On choisit une case au hasard
		{	
			caseChoisie = choisirCaseHasard(tabCases);
		}
		return caseChoisie;
	}

	//Choix Softmax :
	public int choisirCaseAvecApprentissage2(Case[] tabCases)
	{
		int caseChoisie=10;
		double[] probaChoix = new double[9];
		double[] qualite = new double[9];
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{
				int[][] etat = creerEtat(tabCases, i);
				if(dejaVisite(etat)!=null)
				{
					qualite[i] = memoire.get(dejaVisite(etat))[1];
				}
				else
				{
					Double[] recMemoire=new Double[2];
					recMemoire[0]=1.0;
					if(initialisation)
					{
						recMemoire[1]=this.probaVictoireInitiale(tabCases, i);
					}
					else
					{
						recMemoire[1]=0.5;
					}
					memoire.put(etat, recMemoire);//On ajoute l'tat en mmoire
					qualite[i] = recMemoire[1];
				}
			}
			else
			{
				qualite[i]=0;
			}
		}
		
		double sommeQualite=0;
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{	
				sommeQualite=qualite[i]+sommeQualite;
			}
		}
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{	
				probaChoix[i]=qualite[i]/sommeQualite;
			}
		}
		double[] valeursIntervalle=new double[9];
		for(int i=0; i<9; i++)
		{
			if(i==0)
			{
				valeursIntervalle[i]= 0 + probaChoix[i];
			}
			else
			{
				valeursIntervalle[i]=valeursIntervalle[i-1]+probaChoix[i];
			}
		}
		
		double choix=hasard();
		if( 0<=choix && choix<valeursIntervalle[0])
		{
			caseChoisie=0;
		}
		else if(valeursIntervalle[0]<=choix && choix<valeursIntervalle[1])
		{
			caseChoisie=1;
		}
		else if(valeursIntervalle[1]<=choix && choix<valeursIntervalle[2])
		{
			caseChoisie=2;
		}
		else if(valeursIntervalle[2]<=choix && choix<valeursIntervalle[3])
		{
			caseChoisie=3;
		}
		else if(valeursIntervalle[3]<=choix && choix<valeursIntervalle[4])
		{
			caseChoisie=4;
		}
		else if(valeursIntervalle[4]<=choix && choix<valeursIntervalle[5])
		{
			caseChoisie=5;
		}
		else if(valeursIntervalle[5]<=choix && choix<valeursIntervalle[6])
		{
			caseChoisie=6;
		}
		else if(valeursIntervalle[6]<=choix && choix<valeursIntervalle[7])
		{
			caseChoisie=7;
		}
		else if(valeursIntervalle[7]<=choix && choix<=valeursIntervalle[8])
		{
			caseChoisie=8;
		}
		return caseChoisie;
	}
	
	//Choix Boltzmann :
	public int choisirCaseAvecApprentissage3(Case[] tabCases)
	{
		double nbrPassagesGlobalMoyen=1;
		int casesLibres=0;
		int caseChoisie=10;		//valeur par dfaut si on ne peut pas choisir de case
		for(int i=0; i<9; i++)//On compte le nbr de fois que l'on est pass par ce tableau.
		{
			if(tabCases[i].getType()==0)
			{	
				casesLibres++;
				int[][] etat = creerEtat(tabCases, i);
				if(dejaVisite(etat)!=null)
				{
					nbrPassagesGlobalMoyen=(casesLibres*nbrPassagesGlobalMoyen+ memoire.get(dejaVisite(etat))[0])/(casesLibres+1);
				}
			}
		}
		double tauActuel = tau/nbrPassagesGlobalMoyen;
		double[] probaChoix = new double[9];
		double[] qualite = new double[9];
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{
				int[][] etat = creerEtat(tabCases, i);
				if(dejaVisite(etat)!=null)
				{
					qualite[i] = memoire.get(dejaVisite(etat))[1];
				}
				else
				{
					Double[] recMemoire=new Double[2];
					recMemoire[0]=1.0;
					if(initialisation)
					{
						recMemoire[1]=this.probaVictoireInitiale(tabCases, i);
					}
					else
					{
						recMemoire[1]=0.5;
					}
					memoire.put(etat, recMemoire);//On ajoute l'tat en mmoire
					qualite[i] = recMemoire[1];
				}
			}
		}
		double sommeQualite=0;
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{	
				sommeQualite=Math.exp(qualite[i]/tauActuel)+sommeQualite;
			}
		}
		for(int i=0; i<9; i++)
		{
			if(tabCases[i].getType()==0)
			{	
				probaChoix[i]=Math.exp(qualite[i]/tauActuel)/sommeQualite;
			}
			else
			{
				probaChoix[i]=0;
			}
		}
		double[] valeursIntervalle=new double[9];
		for(int i=0; i<9; i++)
		{
			if(i==0)
			{
				valeursIntervalle[i]= 0 + probaChoix[i];
			}
			else
			{
				valeursIntervalle[i]=valeursIntervalle[i-1]+probaChoix[i];
			}
		}
		double choix=hasard();
		if( 0<=choix && choix<valeursIntervalle[0])
		{
			caseChoisie=0;
		}
		else if(valeursIntervalle[0]<=choix && choix<valeursIntervalle[1])
		{
			caseChoisie=1;
		}
		else if(valeursIntervalle[1]<=choix && choix<valeursIntervalle[2])
		{
			caseChoisie=2;
		}
		else if(valeursIntervalle[2]<=choix && choix<valeursIntervalle[3])
		{
			caseChoisie=3;
		}
		else if(valeursIntervalle[3]<=choix && choix<valeursIntervalle[4])
		{
			caseChoisie=4;
		}
		else if(valeursIntervalle[4]<=choix && choix<valeursIntervalle[5])
		{
			caseChoisie=5;
		}
		else if(valeursIntervalle[5]<=choix && choix<valeursIntervalle[6])
		{
			caseChoisie=6;
		}
		else if(valeursIntervalle[6]<=choix && choix<valeursIntervalle[7])
		{
			caseChoisie=7;
		}
		else if(valeursIntervalle[7]<=choix && choix<=valeursIntervalle[8])
		{
			caseChoisie=8;
		}
		return caseChoisie;
	}
	
	//retourne la probabilit choisie initialement pour la fonction choisirCaseAvecApprentissage
	//met en mmoire les nouveaux tats.
	public double probaVictoireInitiale(Case[] tabCases, int indiceCase)
	{
		HashMap< Integer, int[]> listeLigneIndice = ligne(indiceCase);
		Iterator<Integer> it = listeLigneIndice.keySet().iterator();
		double rec=0.5;
		while(it.hasNext())
		{
			Integer clef = it.next();
			int[] ligne = listeLigneIndice.get(clef);
			int nbrCroix=0;
			int nbrRonds=0;
			for(int i=0; i<3;i++) //on compte le nbr de ronds et de croix sur la ligne
			{
				int type = tabCases[ligne[i]].getType();
				if(type==1)
				{
					nbrRonds++;
				}
				else if(type==2)
				{
					nbrCroix++;
				}
			}
			if(nbrCroix==2&& rec<1)
			{
				if(signeIa==2)
				{
					rec = 1;
				}
				else
				{
					rec=0.70;
				}
			}
			else if(nbrRonds==2&& rec<1)
			{
				if(signeIa==1)
				{
					rec = 1;
				}
				else
				{
					rec=0.70;
				}
			}
			else if(nbrRonds==1&& rec<0.7)
			{
				if(signeIa==1)
				{
					rec = 0.6;
				}
			}
			else if(nbrCroix==1&& rec<0.7)
			{
				if(signeIa==2)
				{
					rec = 0.6;
				}
			}
		}
		return rec;
	}//fin probaVicoireInitiale.
	
	//met  jour la mmoire en utilisant gamma.
	public void mettreAJourMemoire(boolean victoire) 
	{
		if(victoire) //si le pc a gagn
		{	
			for(int numeroCoup=1; numeroCoup<=nbrCoups; numeroCoup++) //on parcoure l'ensemble des tats de la partie pour leur reatribuer une recompense
			{
				mettreAJourValeurEtat(numeroCoup, recPartieGagnee/((nbrCoups - numeroCoup +1)));
				//mettreAJourValeurEtat(numeroCoup, recPartieGagnee/((nbrCoups - numeroCoup +1)*(nbrCoups - numeroCoup +1)));
			}
		}//fin si victoire pc
		else //si le pc a perdu
		{
			for(int numeroCoup=1; numeroCoup<=nbrCoups; numeroCoup++) //on parcoure l'ensemble des tats de la partie pour leur reatribuer une recompense
			{
				mettreAJourValeurEtat(numeroCoup, recPartiePerdue/((nbrCoups - numeroCoup +1)));
				//mettreAJourValeurEtat(numeroCoup,recPartiePerdue/((nbrCoups - numeroCoup +1)*(nbrCoups - numeroCoup +1)));
			}
		}//fin sinon	
	}// fin MAJ memoire
	
	public void mettreAJourValeurEtat(int numeroCoup, double retour)
	
	{
		int[][] etat = new int[9][2];
		Double[] rec =new Double[2]; 
		etat = dejaVisite(partie.get(numeroCoup));
		rec = memoire.get(etat);
		rec[1]=rec[1];
		if (numeroCoup == nbrCoups)
		{
			rec[0] = rec[0]+1;
			rec[1] = retour; //si c'est le dernier coup, c'est qu'il est gagnant ou perdant
		}
		else
		{
			if (dejaVisite(partie.get(numeroCoup+1))!=null)
			{
				int[][] etatSuivant = dejaVisite(partie.get(numeroCoup+1));
				rec[1]= rec[1]+(retour + gamma*memoire.get(etatSuivant)[1]-rec[1])/(rec[0]+1);
				rec[0]= rec[0]+1;
			}
			else
			{
				if(numeroCoup+1 == nbrCoups)
				{
					rec[1]= rec[1]+1/(rec[0]+1)*(retour + gamma*retour-rec[1]);
					rec[0]= rec[0]+1;
				}
				else
				{
					rec[1]= rec[1]+1/(rec[0]+1)*(retour + gamma*0.5-rec[1]);
					rec[0]= rec[0]+1;
				}
			}
		}
		memoire.put(etat, rec);
	}

	
	//----------------------------------------------------------------------------------------
	
	
	//----------------------------------------------------------------------------------------
	//Accesseurs :
	
	public void setMemoire(HashMap<int[][], Double[]> memoire)
	{
		this.memoire = memoire;
	}
	
	public int getFonctionUtilisee()
	{
		return fonctionUtilisee;
	}
	
	public void setFonctionUtilisee(int fonctionUtilisee)
	{
		this.fonctionUtilisee = fonctionUtilisee;
	}
	
	public int getSigneIa()
	{
		return signeIa;
	}

	public void setSigneIa(int i)
	{
		this.signeIa= i;
	}
	
	public double getTau()
	{
		return this.tau;
	}
	
	public void setTau(double tau)
	{
		this.tau=tau;
	}
	
	public boolean getInitialisation()
	{
		return initialisation;
	}
	
	public void  setInitialisation(boolean initialisation)
	{
		this.initialisation=initialisation;
	}
	
	public double getProbaHasard()
	{
		return probaJeuxHasard;
	}
	
	public void setProbaHasard(double probaJeuxHasard)
	{
		this.probaJeuxHasard=probaJeuxHasard;
	}
	
	public double getGamma()
	{
		return gamma;
	}
	
	public void setGamma(double gamma)
	{
		this.gamma=gamma;
	}
	
	public double getRecPartieGagnee()
	{
		return recPartieGagnee;
	}
	
	public void setRecPartieGagnee(double recPartieGagnee)
	{
		this.recPartieGagnee=recPartieGagnee;
	}
	
	public double getRecPartiePerdue()
	{
		return recPartiePerdue;
	}
	
	public void setRecPartiePerdue(double recPartiePerdue)
	{
		this.recPartiePerdue=recPartiePerdue;
	}
	
	public void setNbrCoups(int i)
	{
		nbrCoups = i;
	}
	
	public double getNbrPartiesJouees()
	{
		return nbrPartiesJouees;
	}
	
	public void ajouterPartie(int fin)//fin vaut 0 si dfaite, 1 si victoire, 2 si nul
	{
		Integer nbrParties=(int) Math.floor(nbrPartiesJouees); 
		tabParties.put(nbrParties, fin);
	}
	
	public HashMap<Integer,Integer> getTabParties()
	{
		return this.tabParties;
	}
	
	public void setNouvellePartie()
	{
		this.partie = new HashMap<Integer,int[][]>();
		this.setNbrCoups(0);
		this.nbrPartiesJouees= this.nbrPartiesJouees+1;
	}
	//----------------------------------------------------------------------------------------
	
	//----------------------------------------------------------------------------------------
	//Autres fonction utiles :
	
	public void ajouterEtapePartie(Case[] tabCases, int i)
	{
		nbrCoups++;
		int[] tabInitial = new int[9];
		int[] tabResultant = new int[9];
		int[][] etat = new int[9][2];
		for(int j=0; j<9; j++)
		{
			if(j!=i)
			{
				tabInitial[j] = tabCases[j].getType();
				tabResultant[j] = tabCases[j].getType();
			}
			else
			{
				tabInitial[j] = tabCases[j].getType();
				tabResultant[j] = signeIa;
			}	
		}
		etat[1]=tabInitial;
		etat[2]=tabResultant;
		partie.put(new Integer(nbrCoups), etat);	
	}

	public boolean etatsIdentiques(int[][] etat1,int[][] etat2)
	{
		if(tableauxIdentiques(etat1[1],etat2[1])&&tableauxIdentiques(etat1[2],etat2[2]))
			return true;
		else	
			return false;
			
	}
	
	public boolean tableauxIdentiques (int[] tab1, int[] tab2)//Dit si deux tableaux sont identiques
	{
		if (tab1.length!=tab2.length)
		{
			return false;
		}
		else
		{
			boolean estIdentique = true;
			for(int i=0; i<tab1.length; i++)
			{
				estIdentique = estIdentique && (tab1[i]== tab2[i]);
			}
			return estIdentique;
		}
	}
	
	public double hasard()	//fonction retournant un double entre 0 et 1 au hasard
	{
		Random r = new Random();
		return r.nextDouble();
	}

	public int[][] dejaVisite (int[][] etat)//retourne l'tat correspondant  tabCases en mmoire(lui meme ou
									// un de ses symtriques) si lui ou ce symetrique a dja t visit, retourne null sinon
	{
		Iterator<int[][]> itMemoire = memoire.keySet().iterator();
		while(itMemoire.hasNext()) //on cherche si lors de la partie on est pass par des tats dja parcourus
		{
			int[][] etatRelatif = itMemoire.next();
			boolean estIdentique = etatsIdentiques(etatRelatif, etat) || etatsIdentiques(etatRelatif, sym1(etat)) || etatsIdentiques(etatRelatif, sym2(etat)) || etatsIdentiques(etatRelatif, sym3(etat)) || etatsIdentiques(etatRelatif, sym4(etat)) || etatsIdentiques(etatRelatif, rot1(etat)) || etatsIdentiques(etatRelatif, rot2(etat)) || etatsIdentiques(etatRelatif, rot3(etat));
			if(estIdentique)
			{
				return etatRelatif;
			}
		}
		return  null;
	}
	
	public int[][] creerEtat(Case[] tabCases, int i)
	{
		int[] tabCasesResultantAction = new int[9];
		int[] tabCasesInitial = new int[9];
		int[][] etat = new int[9][2]; 
		for(int j = 0; j<9; j++)
		{
			if(j!=i)
			{
				tabCasesResultantAction[j]=tabCases[j].getType();
				tabCasesInitial[j]=tabCases[j].getType();
			}
			else
			{
				tabCasesResultantAction[j]= signeIa;
				tabCasesInitial[j]=tabCases[j].getType();
			}
		}
		etat[1]= tabCasesInitial;
		etat[2]= tabCasesResultantAction;
		return etat;
	}
	
	public  HashMap< Integer, int[]> ligne(int i) //fonction qui donne dans une hashMap 
											//les numeros des cases alignes avec la case ni
	{
		int[] ligne0 = new int[3];
		int[] ligne1 = new int[3];
		int[] ligne2 = new int[3];
		int[] ligne3 = new int[3];
		
		switch (i) {
		case 0: HashMap< Integer, int[]> hm0 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=1;
				ligne0[2]=2;
				hm0.put(new Integer(0), ligne0);
				ligne1[0]=0;
				ligne1[1]=4;
				ligne1[2]=8;
				hm0.put(new Integer(1), ligne1);
				ligne2[0]=0;
				ligne2[1]=3;
				ligne2[2]=6;			
				hm0.put(new Integer(2), ligne2);
				return hm0;
				
		case 1: HashMap< Integer, int[]> hm1 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=1;
				ligne0[2]=2;
				hm1.put(new Integer(0), ligne0);
				ligne1[0]=1;
				ligne1[1]=4;
				ligne1[2]=7;
				hm1.put(new Integer(1), ligne1);
				return hm1;
				
		case 2: HashMap< Integer, int[]> hm2 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=1;
				ligne0[2]=2;
				hm2.put(new Integer(0), ligne0);
				ligne1[0]=2;
				ligne1[1]=4;
				ligne1[2]=6;
				hm2.put(new Integer(1), ligne1);
				ligne2[0]=2;
				ligne2[1]=5;
				ligne2[2]=8;
				hm2.put(new Integer(2), ligne2);
				return hm2;
				
		case 3: HashMap< Integer, int[]> hm3 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=3;
				ligne0[2]=6;
				hm3.put(new Integer(0), ligne0);
				ligne1[0]=3;
				ligne1[1]=4;
				ligne1[2]=5;
				hm3.put(new Integer(1), ligne1);
				return hm3;
				
		case 4: HashMap< Integer, int[]> hm4 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=4;
				ligne0[2]=8;
				hm4.put(new Integer(0), ligne0);
				ligne1[0]=3;
				ligne1[1]=4;
				ligne1[2]=5;
				hm4.put(new Integer(1), ligne1);
				ligne2[0]=2;
				ligne2[1]=4;
				ligne2[2]=6;
				hm4.put(new Integer(2), ligne2);
				ligne3[0]=1;
				ligne3[1]=4;
				ligne3[2]=7;
				hm4.put(new Integer(3), ligne3);
				return hm4;
				
		case 5: HashMap< Integer, int[]> hm5 = new HashMap< Integer, int[]>();
				ligne0[0]=2;
				ligne0[1]=5;
				ligne0[2]=8;
				hm5.put(new Integer(0), ligne0);
				ligne1[0]=3;
				ligne1[1]=4;
				ligne1[2]=5;
				hm5.put(new Integer(1), ligne1);
				return hm5;
				
		case 6: HashMap< Integer, int[]> hm6 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=3;
				ligne0[2]=6;
				hm6.put(new Integer(0), ligne0);
				ligne1[0]=2;
				ligne1[1]=4;
				ligne1[2]=6;
				hm6.put(new Integer(1), ligne1);
				ligne2[0]=6;
				ligne2[1]=7;
				ligne2[2]=8;
				hm6.put(new Integer(2), ligne2);
				return hm6;
				
		case 7: HashMap< Integer, int[]> hm7 = new HashMap< Integer, int[]>();
				ligne0[0]=1;
				ligne0[1]=4;
				ligne0[2]=7;
				hm7.put(new Integer(0), ligne0);
				ligne1[0]=6;
				ligne1[1]=7;
				ligne1[2]=8;
				hm7.put(new Integer(1), ligne1);
				return hm7;
				
		case 8: HashMap< Integer, int[]> hm8 = new HashMap< Integer, int[]>();
				ligne0[0]=0;
				ligne0[1]=4;
				ligne0[2]=8;
				hm8.put(new Integer(0), ligne0);
				ligne1[0]=2;
				ligne1[1]=5;
				ligne1[2]=8;
				hm8.put(new Integer(1), ligne1);
				ligne2[0]=6;
				ligne2[1]=7;
				ligne2[2]=8;
				hm8.put(new Integer(2), ligne2);
				return hm8;
				
		default:System.out.println("Case inexistante.");
				return null;		
		}	
	}

	//Ces fonctions retournent les tats symtriques
	
	public int[][] sym1(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= sym1tab(etat[1]);
		resultat[2]= sym1tab(etat[2]);
		return resultat;
	}
	
	public int[][] sym2(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= sym2tab(etat[1]);
		resultat[2]= sym2tab(etat[2]);
		return resultat;
	}
	
	public int[][] sym3(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= sym3tab(etat[1]);
		resultat[2]= sym3tab(etat[2]);
		return resultat;
	}
	
	public int[][] sym4(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= sym4tab(etat[1]);
		resultat[2]= sym4tab(etat[2]);
		return resultat;
	}
	
	public int[][] rot1(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= rot1tab(etat[1]);
		resultat[2]= rot1tab(etat[2]);
		return resultat;
	}
	
	public int[][] rot2(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= rot2tab(etat[1]);
		resultat[2]= rot2tab(etat[2]);
		return resultat;
	}
	
	public int[][] rot3(int[][] etat)
	{
		int[][] resultat = new int[9][2];
		resultat[1]= rot3tab(etat[1]);
		resultat[2]= rot3tab(etat[2]);
		return resultat;
	}
	
	public int[] sym1tab (int[] tabCases)
	{
		int[] sym1tabCases = new int[9];
		sym1tabCases[0] = tabCases[2];
		sym1tabCases[1] = tabCases[1];
		sym1tabCases[2] = tabCases[0];
		sym1tabCases[3] = tabCases[5];
		sym1tabCases[4] = tabCases[4];
		sym1tabCases[5] = tabCases[3];
		sym1tabCases[6] = tabCases[8];
		sym1tabCases[7] = tabCases[7];
		sym1tabCases[8] = tabCases[6];
		return sym1tabCases;
	}
	
	public int[] sym2tab (int[] tabCases)
	{
		int[] sym2tabCases = new int[9];
		sym2tabCases[0] = tabCases[6];
		sym2tabCases[1] = tabCases[7];
		sym2tabCases[2] = tabCases[8];
		sym2tabCases[3] = tabCases[3];
		sym2tabCases[4] = tabCases[4];
		sym2tabCases[5] = tabCases[5];
		sym2tabCases[6] = tabCases[0];
		sym2tabCases[7] = tabCases[1];
		sym2tabCases[8] = tabCases[2];
		return sym2tabCases;
	}
	
	public int[] sym3tab (int[] tabCases)
	{
		int[] sym3tabCases = new int[9];
		sym3tabCases[0] = tabCases[8];
		sym3tabCases[1] = tabCases[5];
		sym3tabCases[2] = tabCases[2];
		sym3tabCases[3] = tabCases[7];
		sym3tabCases[4] = tabCases[4];
		sym3tabCases[5] = tabCases[1];
		sym3tabCases[6] = tabCases[6];
		sym3tabCases[7] = tabCases[3];
		sym3tabCases[8] = tabCases[0];
		return sym3tabCases;
	}
	
	public int[] sym4tab (int[] tabCases)
	{
		int[] sym4tabCases = new int[9];
		sym4tabCases[0] = tabCases[0];
		sym4tabCases[1] = tabCases[3];
		sym4tabCases[2] = tabCases[6];
		sym4tabCases[3] = tabCases[1];
		sym4tabCases[4] = tabCases[4];
		sym4tabCases[5] = tabCases[7];
		sym4tabCases[6] = tabCases[2];
		sym4tabCases[7] = tabCases[5];
		sym4tabCases[8] = tabCases[8];
		return sym4tabCases;
	}
	
	public int[] rot1tab (int[] tabCases)
	{
		int[] rot1tabCases = new int[9];
		rot1tabCases[0] = tabCases[6];
		rot1tabCases[1] = tabCases[3];
		rot1tabCases[2] = tabCases[0];
		rot1tabCases[3] = tabCases[7];
		rot1tabCases[4] = tabCases[4];
		rot1tabCases[5] = tabCases[1];
		rot1tabCases[6] = tabCases[8];
		rot1tabCases[7] = tabCases[5];
		rot1tabCases[8] = tabCases[2];
		return rot1tabCases;
	}
	
	public int[] rot2tab (int[] tabCases)
	{
		return (rot1tab(rot1tab(tabCases)));
	}
	
	public int[] rot3tab (int[] tabCases)
	{
		return rot1tab(rot1tab(rot1tab(tabCases)));
	}
	//----------------------------------------------------------------------------------------
	
}//fin classe
